#!/usr/bin/perl -T
use strict ;
use MIME::Base64 ;
use LWP ;

$::formptr = &get_inputs ;
my ( $url, $host ) = &url($::formptr->{'url'}) ;

&error('cg-eye live will not call itself')
  if ( ( $host eq $ENV{'HTTP_HOST'} ) && ( $url =~ /cg.eye/ ) ) ;
  
my $response = &fetch_form($url, $host) ;
&error("HTTP request to $url returned error ".$response->code
	. '(' . HTTP::Status::status_message($response->code).')')
	unless HTTP::Status::is_success($response->code) ;

$response->content_type =~ /^text\/html/i
  or &error("Content of $url is not an HTML document (this is a BUG\
  in your server, since cg-eye insisted on HTML or nothing).") ;

my $body = $response->content ;
$body =~ s/<\s+/</g ;
$body =~ s/\s+>/>/g ;
$body =~ s/(<form.*?>)/&encode_form($1,$response)/geis 
  or &error("No HTML Form found at $url") ;

my $base = qq(<base href=") . $response->base . qq(">) ;
if ( $body =~ /<head>(.*?)<\/head>/sig ) {
  my $head = $1 ;
  $body =~ s/<head>/<head>$base/si
    unless $head =~ /<base\s+.*>/si ;
} else {
  $body =~ s/(<title>.*?<\/title>)/<head>$base$1<\/head>/is
  or $body =~ s//<head><title>Error - untitled document<\/title>$base<\/head>/ ;
}
  

print <<ENDHDRS;
Content-Type: text/html
Cache-Control: public
Connection: close

ENDHDRS
print $body ;
exit ;

sub encode_form {
  $_ = shift ;
  my $res = shift ;
  s/\s*=\s*/=/g ;
  /enctype=/is and 
    &error("cg-eye live doesn't support expicit ENCTYPE - use default") ;
  /method=['"]?(POST|GET)/is or
    &error("cg-eye live requires GET or POST method") ;

  s/action=([^\s\>]+)/action="$::baseurl\/cgeye.cgi"/is
    or &error("Don't understand your Form's Action") ;
  my $action = $1 ;
  $action =~ s/["']//g ;

  unless ($action =~ /http:/) {
    my $base = $res->base ;
    $base =~ /(.*\/)/ ;
    $action = $1 . $action ;
  }

  return $_ 
	. qq(<input type=hidden name="cgeye_url" value="$action">)
	. &hidden('username')
	. &hidden('password')
	. &hidden('cookie')
	. &hidden('source')
	. &hidden('valid')
  ;
}
sub hidden {
  my $param = shift ;
  return $::formptr->{$param}
	? qq(<input type=hidden name="cgeye_$param" value=") 
		. escape($::formptr->{$param}) . q(">)
	: ''
  ;
}
sub fetch_form {
  my ( $url, $host ) = @_ ;
  my $agent = new LWP::UserAgent ;
  $agent->agent('cg-eye live') ;
  my $auth = "Basic "
	. MIME::Base64::encode_base64
		($::formptr->{'username'} .':'. $::formptr->{'password'} ) ;
  my $header = new HTTP::Headers 
	'From'          =>      'cg-eye@htmlhelp.org' ,
	'Connection'    =>      'Close' ,
	'Accept'        =>      'text/html' ,
	'Referer'       =>      "$::baseurl/fetch.cgi" ,
	'Authorization' =>      $auth ,
	'Host'          =>      $host
  ;
  my $req = new HTTP::Request 'GET', $url, $header ;
  return $agent->request($req) ;
}
sub get_inputs {
  my %FORM ;
  my @pairs = split(/&/, $ENV{'QUERY_STRING'});
  foreach (@pairs) {
    my ($name, $value) = split(/=/, $_);

    # Un-Webify plus signs and %-encoding
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ s/~!/ ~!/g;
  
    $FORM{$name} = $value;
  }
  return \%FORM ;
}
sub url {
  my $URL = shift ;
  $URL =~ /^http:\/\/([\w\-\.]+)(:\d+)?(.*)$/
	or &error('Cannot accept URL ' . $URL) ;
  my ($server, $port, $path) = ($1,$2,$3) ;
  my $url = "http://$server$port$path" ;

  return ($url, $server) ;
}
sub escape {
  $_ = shift ;
  s/&/&amp;/g ;
  s/</&lt;/g ;
  s/>/&gt;/g ;
  $_ ;
}
sub error {
  $_ = shift ;
  print "Content-Type: text/html\n\n<title>cg-eye Error</title>" ,
	"<h1>Error</h1>", $_;
  exit ;
}

BEGIN {
  $::baseurl = "http://your.server/cgi-bin" ;
}
